::WEAPON_TYPES <- [
    {
        names = ["tommygun"],
        baseclass = "tf_weapon_handgun_scout_primary",
        baseid = 16,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl",
        weaponmodel = "models/weapons/w_models/w_tommygun_test.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("bullets per shot bonus", 0.75, -1);
            weaponEnt.AddAttribute("fire rate bonus", 0.25, -1);
            weaponEnt.AddAttribute("clip size bonus", 10, -1);
            weaponEnt.AddAttribute("damage bonus HIDDEN", 0.44, -1);
            weaponEnt.AddAttribute("dmg falloff decreased", 0.3, -1);
            weaponEnt.AddAttribute("hidden primary max ammo bonus", 0.6, -1);
            weaponEnt.AddAttribute("reload time increased", 1.0, -1);
            weaponEnt.SetClip1(40);
        }
    },
    {
        names = ["money_bag"],
        baseclass = "tf_weapon_cleaver",
        baseid = 46,
        animmodel = "models/weapons/c_models/c_scout_arms.mdl",
        weaponmodel = "models/vip/weapons/c_models/money_bag.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            local bagThrowTime = player.GetScriptScope().bagThrowTime;
            weaponEnt.AddAttribute("override projectile type", 1, -1);
            if (bagThrowTime < Time() + 100)
            {
                RunWithDelay(-1, function() {
                    SetPropIntArray(player, "m_iAmmo", 0, 5);
                    weaponEnt.SetClip1(0);
                })
            }
        },
        OnFire = function(player, weaponTT, weaponEnt) {
            player.ValidateScriptScope();
            player.GetScriptScope().bagThrowTime <- Time();
            RunWithDelay(0.2, function() {
                local projectile = SpawnEntityFromTable("prop_physics_override", {
                    model = "models/vip/weapons/c_models/money_bag.mdl"
                    origin = player.EyePosition()
                    spawnflags = "4",
                    massscale = 5
                });
                projectile.SetPhysVelocity(player.EyeAngles().Forward() * 4400 + Vector(0, 0, 200));
                AddTimer(-1, function()
                {
                    local trace = {
                        start = self.GetOrigin(),
                        end = self.GetOrigin() - Vector(0, 0, 20),
                        ignore = self
                    };
                    TraceLineEx(trace);
                    if (!safeget(trace, "enthit", player).IsPlayer())
                    {
                        local moneyFountain = SpawnEntityFromTable("prop_dynamic",
                        {
                            origin = self.GetOrigin(),
                            vscripts = "vip/entities/money_fountain.nut",
                            TeamNum = GetFakeTeam(player)
                        });
                        moneyFountain.SetOwner(player);
                        self.Kill();
                    }
                }, projectile)
            });
        }
    },
    {
        names = ["snipistol"],
        baseclass = "tf_weapon_pistol",
        baseid = 23,
        animmodel = "models/weapons/c_models/c_spy_arms.mdl",
        weaponmodel = "models/workshop/weapons/c_models/c_ttg_sam_gun/c_ttg_sam_gun.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("clip size bonus", 0.05, -1);
            weaponEnt.AddAttribute("damage bonus", 5.5, -1);
            weaponEnt.AddAttribute("dmg falloff decreased", 5, -1);
            weaponEnt.AddAttribute("reload time increased", 2.5, -1);
            weaponEnt.AddAttribute("hidden secondary max ammo penalty", 0.2, -1);
            weaponEnt.AddAttribute("sniper fires tracer", 1, -1);
            weaponEnt.SetClip1(1);
        },
        OnSwitch = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(1); //todo infinite ammo glitch
        }
    },
    {
        names = ["cane"],
        baseclass = "tf_weapon_shovel",
        animmodel = API_GetString("vip_arms_model"),
        weaponmodel = API_GetString("cane_model"),
        baseid = 196,
        OnEquip = function(player, weaponTT, weaponEnt) {
            //weaponEnt.AddAttribute("damage bonus HIDDEN", 0.54, -1);
            //weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.625, -1);
        }
    }
];