characterName <- "vip";
characterClass <- TF_CLASS_HEAVY;
characterModel <- API_GetString("vip_model");
characterArms <- "models/weapons/c_models/c_spy_arms.mdl";

IncludeScript("vip/vip/vip_moneybag_recharge.nut");
IncludeScript("vip/vip/vip_headshot.nut");
IncludeScript("vip/vip/vip_nag.nut");
IncludeScript("vip/vip/vip_mediccall.nut");
IncludeScript("vip/vip/vip_fixes.nut");
IncludeScript("vip/vip/vip_experiments.nut");
IncludeScript("vip/vip/vip_failsafe.nut");

OnSelfGameEvent("post_inventory_application_post", 0, function()
{
    self.KeyValueFromString("targetname", "vip");

    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("patient overheal penalty", 0.2, -1);
    self.AddCustomAttribute("airblast vulnerability multiplier", 0.4, -1);

    self.SetHealth(500);
    self.SetMaxHealth(500);
    self.RemoveCustomAttribute("max health additive penalty");
    self.AddCustomAttribute("max health additive penalty", 200, -1);
    self.RemoveCond(TF_COND_DISGUISED);
    self.RemoveCond(TF_COND_DISGUISING);

    self.SetModelScale(API_GetFloat("vip_scale"), -1);

    self.Weapon_Switch(EquipWeapon(GetWeaponTypeByName("tommygun")));
    EquipWeapon(GetWeaponTypeByName("money_bag"));
    EquipWeapon(GetWeaponTypeByName("cane"));

    foreach (otherPlayer in GetAlivePlayers())
    {
        if (otherPlayer.GetPlayerClass() != TF_CLASS_MEDIC)
            return;
        local medigun = otherPlayer.GetActiveWeapon();
        if (GetPropEntity(medigun, "m_hHealingTarget") == self)
            SetPropEntity(medigun, "m_hHealingTarget", null);
    }
});

OnSelfEvent("player_death", 0, function(params)
{
    DoEntFire(GetFakeTeamName(self) + "_vip_death*", "Trigger", "", -1, self, self);
    FireCustomEvent("vip_death", params);
    vipPlayers[GetFakeTeam(self)] = null;
});